Index: trunk/lib/FlairCore/src/Vector3DSpinBox.h
===================================================================
--- trunk/lib/FlairCore/src/Vector3DSpinBox.h	(revision 14)
+++ trunk/lib/FlairCore/src/Vector3DSpinBox.h	(revision 15)
@@ -17,54 +17,57 @@
 #include <Vector3D.h>
 
-namespace flair { namespace gui {
-    class Layout;
+namespace flair {
+namespace gui {
+class Layout;
 
-    /*! \class Vector3DSpinBox
-    *
-    * \brief Class displaying 3 QDoubleSpinBox for x,y,z on the ground station
-    *
-    */
-    class Vector3DSpinBox: public Box {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Vector3DSpinBox at given position. \n
-            * Each DoubleSpinBox is saturated to min and max values.
-            *
-            * \param position position to display the Vector3DSpinBox
-            * \param name name
-            * \param min minimum value
-            * \param max maximum value
-            * \param step step
-            * \param decimals number of decimals
-            * \param default_value default value if not in the xml config file
-            */
-            Vector3DSpinBox(const LayoutPosition* position,std::string name,double min,double max,double step,int decimals=2,core::Vector3D default_value=core::Vector3D(0,0,0));
+/*! \class Vector3DSpinBox
+*
+* \brief Class displaying 3 QDoubleSpinBox for x,y,z on the ground station
+*
+*/
+class Vector3DSpinBox : public Box {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Vector3DSpinBox at given position. \n
+  * Each DoubleSpinBox is saturated to min and max values.
+  *
+  * \param position position to display the Vector3DSpinBox
+  * \param name name
+  * \param min minimum value
+  * \param max maximum value
+  * \param step step
+  * \param decimals number of decimals
+  * \param default_value default value if not in the xml config file
+  */
+  Vector3DSpinBox(const LayoutPosition *position, std::string name, double min,
+                  double max, double step, int decimals = 2,
+                  core::Vector3D default_value = core::Vector3D(0, 0, 0));
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Vector3DSpinBox();
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Vector3DSpinBox();
 
-            /*!
-            * \brief Value
-            *
-            * \return value
-            */
-            core::Vector3D Value(void) const;
-            //operator core::Vector3D() const;
-        private:
-            /*!
-            * \brief XmlEvent from ground station
-            *
-            * Reimplemented from Widget.
-            *
-            */
-            void XmlEvent(void);
+  /*!
+  * \brief Value
+  *
+  * \return value
+  */
+  core::Vector3D Value(void) const;
+  // operator core::Vector3D() const;
+private:
+  /*!
+  * \brief XmlEvent from ground station
+  *
+  * Reimplemented from Widget.
+  *
+  */
+  void XmlEvent(void);
 
-            core::Vector3D box_value;
-    };
+  core::Vector3D box_value;
+};
 
 } // end namespace gui
Index: trunk/lib/FlairCore/src/Vector3Ddata.cpp
===================================================================
--- trunk/lib/FlairCore/src/Vector3Ddata.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/Vector3Ddata.cpp	(revision 15)
@@ -25,78 +25,75 @@
 using std::string;
 
-namespace flair { namespace core {
+namespace flair {
+namespace core {
 
-   /*! \class Vector3DdataElement
-    */
-    class Vector3DdataElement: public IODataElement {
-    public:
-        Vector3DdataElement(const Vector3Ddata *data,string name,uint32_t elem):IODataElement(data,name) {
-            this->data=data;
-            this->elem=elem;
-            size=4;
-        }
+/*! \class Vector3DdataElement
+ */
+class Vector3DdataElement : public IODataElement {
+public:
+  Vector3DdataElement(const Vector3Ddata *data, string name, uint32_t elem)
+      : IODataElement(data, name) {
+    this->data = data;
+    this->elem = elem;
+    size = 4;
+  }
 
-        ~Vector3DdataElement() {
-        }
+  ~Vector3DdataElement() {}
 
-        void CopyData(char* dst) const {
-            float value;
-            data->GetMutex();
-            switch(elem) {
-                case X:
-                    value=data->x;
-                    break;
-                case Y:
-                    value=data->y;
-                    break;
-                case Z:
-                    value=data->z;
-                    break;
-                default:
-                    data->Err("type not handled\n");
-                    value=0;
-                    break;
-            }
-            data->ReleaseMutex();
+  void CopyData(char *dst) const {
+    float value;
+    data->GetMutex();
+    switch (elem) {
+    case X:
+      value = data->x;
+      break;
+    case Y:
+      value = data->y;
+      break;
+    case Z:
+      value = data->z;
+      break;
+    default:
+      data->Err("type not handled\n");
+      value = 0;
+      break;
+    }
+    data->ReleaseMutex();
 
-            memcpy(dst,&value,sizeof(float));
-        }
+    memcpy(dst, &value, sizeof(float));
+  }
 
-        ScalarType const &GetDataType() const {
-            return dataType;
-        }
+  ScalarType const &GetDataType() const { return dataType; }
 
-    private:
-        const Vector3Ddata *data;
-        uint32_t elem;
-        FloatType dataType;
-    };
+private:
+  const Vector3Ddata *data;
+  uint32_t elem;
+  FloatType dataType;
+};
 
-Vector3Ddata::Vector3Ddata(const Object* parent, string name,float x,float y,float z,uint32_t n): io_data(parent,name,n), Vector3D(x,y,z) {
+Vector3Ddata::Vector3Ddata(const Object *parent, string name, float x, float y,
+                           float z, uint32_t n)
+    : io_data(parent, name, n), Vector3D(x, y, z) {}
 
+Vector3Ddata::~Vector3Ddata() {}
+
+void Vector3Ddata::CopyDatas(char *dst) const {
+  GetMutex();
+  memcpy(dst, &x, sizeof(float));
+  memcpy(dst + sizeof(float), &y, sizeof(float));
+  memcpy(dst + 2 * sizeof(float), &z, sizeof(float));
+  ReleaseMutex();
 }
 
-Vector3Ddata::~Vector3Ddata() {
-
+IODataElement *Vector3Ddata::XElement(void) const {
+  return new Vector3DdataElement(this, "x", X);
 }
 
-void Vector3Ddata::CopyDatas(char* dst) const {
-    GetMutex();
-    memcpy(dst,&x,sizeof(float));
-    memcpy(dst+sizeof(float),&y,sizeof(float));
-    memcpy(dst+2*sizeof(float),&z,sizeof(float));
-    ReleaseMutex();
+IODataElement *Vector3Ddata::YElement(void) const {
+  return new Vector3DdataElement(this, "y", Y);
 }
 
-IODataElement* Vector3Ddata::XElement(void) const {
-    return new Vector3DdataElement(this,"x",X);
-}
-
-IODataElement* Vector3Ddata::YElement(void) const {
-    return new Vector3DdataElement(this,"y",Y);
-}
-
-IODataElement* Vector3Ddata::ZElement(void) const {
-    return new Vector3DdataElement(this,"z",Z);
+IODataElement *Vector3Ddata::ZElement(void) const {
+  return new Vector3DdataElement(this, "z", Z);
 }
 
Index: trunk/lib/FlairCore/src/Vector3Ddata.h
===================================================================
--- trunk/lib/FlairCore/src/Vector3Ddata.h	(revision 14)
+++ trunk/lib/FlairCore/src/Vector3Ddata.h	(revision 15)
@@ -18,72 +18,70 @@
 #include <Vector3D.h>
 
-namespace flair
-{
-namespace core
-{
+namespace flair {
+namespace core {
 
-    /*! \class Vector3Ddata
-    *
-    * \brief Class defining a 3D vector and a io_data
-    * User must manually use the io_data's Mutex to access to Vector3D values.
-    */
-    class Vector3Ddata: public io_data, public Vector3D
-    {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Vector3D using specified values.
-            *
-            * \param x
-            * \param y
-            * \param z
-            */
-            Vector3Ddata(const Object* parent, std::string name,float x=0,float y=0,float z=0,uint32_t n=1);
+/*! \class Vector3Ddata
+*
+* \brief Class defining a 3D vector and a io_data
+* User must manually use the io_data's Mutex to access to Vector3D values.
+*/
+class Vector3Ddata : public io_data, public Vector3D {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Vector3D using specified values.
+  *
+  * \param x
+  * \param y
+  * \param z
+  */
+  Vector3Ddata(const Object *parent, std::string name, float x = 0, float y = 0,
+               float z = 0, uint32_t n = 1);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Vector3Ddata();
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Vector3Ddata();
 
-            /*!
-            * \brief X Element
-            *
-            * Get a vectorer to x element. This pointer can be used for plotting.
-            *
-            * \return pointer to the element
-            */
-            IODataElement* XElement(void) const;
+  /*!
+  * \brief X Element
+  *
+  * Get a vectorer to x element. This pointer can be used for plotting.
+  *
+  * \return pointer to the element
+  */
+  IODataElement *XElement(void) const;
 
-            /*!
-            * \brief Y Element
-            *
-            * Get a pointer to y element. This pointer can be used for plotting.
-            *
-            * \return pointer to the element
-            */
-            IODataElement* YElement(void) const;
+  /*!
+  * \brief Y Element
+  *
+  * Get a pointer to y element. This pointer can be used for plotting.
+  *
+  * \return pointer to the element
+  */
+  IODataElement *YElement(void) const;
 
-            /*!
-            * \brief Z Element
-            *
-            * Get a pointer to z element. This pointer can be used for plotting.
-            *
-            * \return pointer to the element
-            */
-            IODataElement* ZElement(void) const;
+  /*!
+  * \brief Z Element
+  *
+  * Get a pointer to z element. This pointer can be used for plotting.
+  *
+  * \return pointer to the element
+  */
+  IODataElement *ZElement(void) const;
 
-        private:
-            /*!
-            * \brief Copy datas
-            *
-            * Reimplemented from io_data. \n
-            * See io_data::CopyDatas.
-            *
-            * \param dst destination buffer
-            */
-            void CopyDatas(char* dst) const;
-    };
+private:
+  /*!
+  * \brief Copy datas
+  *
+  * Reimplemented from io_data. \n
+  * See io_data::CopyDatas.
+  *
+  * \param dst destination buffer
+  */
+  void CopyDatas(char *dst) const;
+};
 
 } // end namespace core
Index: trunk/lib/FlairCore/src/Watchdog.cpp
===================================================================
--- trunk/lib/FlairCore/src/Watchdog.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/Watchdog.cpp	(revision 15)
@@ -20,29 +20,33 @@
 namespace core {
 
-Watchdog::Watchdog(const Object* parent,std::function<void()> _expired,Time _timer):Thread(parent,"watchdog",0),expired(_expired),timer(_timer){
-}
+Watchdog::Watchdog(const Object *parent, std::function<void()> _expired,
+                   Time _timer)
+    : Thread(parent, "watchdog", 0), expired(_expired), timer(_timer) {}
 
 Watchdog::~Watchdog() {
-    SafeStop();
-    Join();
+  SafeStop();
+  Join();
 }
 
 void Watchdog::Touch() {
-    if (IsSuspended()) Resume();
+  if (IsSuspended())
+    Resume();
 }
 
 void Watchdog::SetTimer(Time _Timer) {
-    timer=_Timer; Touch();
+  timer = _Timer;
+  Touch();
 }
 
 void Watchdog::Run() {
-    while (!ToBeStopped()) {
-        Time current=GetTime();
-        Time date=current+timer;
-        //Printf("watchdog goes to sleep at %llu, scheduled to wake up at %llu\n",current,date);
-        if (!SuspendUntil(date)) {
-            expired();
-        }
+  while (!ToBeStopped()) {
+    Time current = GetTime();
+    Time date = current + timer;
+    // Printf("watchdog goes to sleep at %llu, scheduled to wake up at
+    // %llu\n",current,date);
+    if (!SuspendUntil(date)) {
+      expired();
     }
+  }
 };
 
Index: trunk/lib/FlairCore/src/Widget.cpp
===================================================================
--- trunk/lib/FlairCore/src/Widget.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/Widget.cpp	(revision 15)
@@ -21,227 +21,196 @@
 using std::string;
 
-namespace flair
-{
-namespace gui
-{
+namespace flair {
+namespace gui {
 
 using namespace core;
 
-Widget::Widget(const Widget* parent,string name,string type): Object(parent,name,type)
-{
-    pimpl_=new Widget_impl(this,parent,name,type);
-}
-
-Widget::~Widget()
-{
-    delete pimpl_;
-}
-
-template <>
-bool Widget::GetPersistentXmlProp(std::string prop,double &value)
-{
-    xmlChar *result=NULL;
-    result=xmlGetProp(pimpl_->file_node,(xmlChar*)prop.c_str());
-
-    if(result!=NULL) {
-        value=xmlXPathCastStringToNumber(result);
-        xmlFree(result);
-        return true;
-    } else {
-        return false;
-    }
-}
-
-template <>
-bool Widget::GetPersistentXmlProp(std::string prop,float &value) {
-    double tmp;
-    if(GetPersistentXmlProp<double>(prop,tmp)) {
-        value=tmp;
-        return true;
-    } else {
-        return false;
-    }
-}
-
-template <>
-bool Widget::GetPersistentXmlProp(std::string prop,bool &value) {
-    double tmp;
-    if(GetPersistentXmlProp<double>(prop,tmp)) {
-        value=tmp;
-        return true;
-    } else {
-        return false;
-    }
-}
-
-template <>
-bool Widget::GetPersistentXmlProp(std::string prop,int32_t &value) {
-    double tmp;
-    if(GetPersistentXmlProp<double>(prop,tmp)) {
-        value=tmp;
-        return true;
-    } else {
-        return false;
-    }
-}
-
-template <>
-bool Widget::GetPersistentXmlProp(std::string prop,uint16_t &value) {
-    double tmp;
-    if(GetPersistentXmlProp<double>(prop,tmp)) {
-        value=tmp;
-        return true;
-    } else {
-        return false;
-    }
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,string value,xmlNodePtr node)
-{
-    if(node==NULL) node=pimpl_->send_node;
-    xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)value.c_str());
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,char* value,xmlNodePtr node)
-{
-    if(node==NULL) node=pimpl_->send_node;
-    xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)value);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,double value,xmlNodePtr node)
-{
-    xmlChar* xmlChar_value=xmlXPathCastNumberToString(value);
-
-    if(node==NULL) node=pimpl_->send_node;
-    xmlSetProp(node,(xmlChar*)prop.c_str(),xmlChar_value);
-    xmlFree(xmlChar_value);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,float value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,int32_t value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,uint32_t value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,int16_t value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,uint16_t value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,int8_t value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,uint8_t value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,bool value,xmlNodePtr node)
-{
-    SetVolatileXmlProp<double>(prop,value,node);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,xmlChar* value,xmlNodePtr node) {
-    if(node==NULL) node=pimpl_->send_node;
-    xmlSetProp(node,(xmlChar*)prop.c_str(),value);
-}
-
-template <>
-void Widget::SetVolatileXmlProp(string prop,DataType const &dataType,xmlNodePtr node) {
-    if(node==NULL) node=pimpl_->send_node;
-    xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)dataType.GetDescription().c_str());
-/*
-    switch(dataType)
-    {
-        case io_data::Float:
-            xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)"float");
-            break;
-        case io_data::Int8_t:
-            xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)"int8_t");
-            break;
-        case io_data::Int16_t:
-            xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)"int16_t");
-            break;
-    }
-    */
-}
-
-template <>
-void Widget::SetPersistentXmlProp(std::string prop,double value) {
-    SetVolatileXmlProp(prop,value);
-    SetVolatileXmlProp(prop,value,pimpl_->file_node);
-}
-
-template <>
-void Widget::SetPersistentXmlProp(std::string prop,float value)
-{
-    SetVolatileXmlProp(prop,value);
-    SetVolatileXmlProp(prop,value,pimpl_->file_node);
-}
-
-template <>
-void Widget::SetPersistentXmlProp(std::string prop,int32_t value)
-{
-    SetVolatileXmlProp(prop,value);
-    SetVolatileXmlProp(prop,value,pimpl_->file_node);
-}
-
-template <>
-void Widget::SetPersistentXmlProp(std::string prop,uint16_t value)
-{
-    SetVolatileXmlProp(prop,value);
-    SetVolatileXmlProp(prop,value,pimpl_->file_node);
-}
-
-template <>
-void Widget::SetPersistentXmlProp(std::string prop,bool value)
-{
-    SetVolatileXmlProp(prop,value);
-    SetVolatileXmlProp(prop,value,pimpl_->file_node);
-}
-
-void Widget::SendXml(void)
-{
-    pimpl_->SendXml();
-}
-
-void Widget::setEnabled(bool status)
-{
-    pimpl_->setEnabled(status);
-}
-
-bool Widget::isEnabled(void) const
-{
-    return pimpl_->isenabled;
-
-}
+Widget::Widget(const Widget *parent, string name, string type)
+    : Object(parent, name, type) {
+  pimpl_ = new Widget_impl(this, parent, name, type);
+}
+
+Widget::~Widget() { delete pimpl_; }
+
+template <> bool Widget::GetPersistentXmlProp(std::string prop, double &value) {
+  xmlChar *result = NULL;
+  result = xmlGetProp(pimpl_->file_node, (xmlChar *)prop.c_str());
+
+  if (result != NULL) {
+    value = xmlXPathCastStringToNumber(result);
+    xmlFree(result);
+    return true;
+  } else {
+    return false;
+  }
+}
+
+template <> bool Widget::GetPersistentXmlProp(std::string prop, float &value) {
+  double tmp;
+  if (GetPersistentXmlProp<double>(prop, tmp)) {
+    value = tmp;
+    return true;
+  } else {
+    return false;
+  }
+}
+
+template <> bool Widget::GetPersistentXmlProp(std::string prop, bool &value) {
+  double tmp;
+  if (GetPersistentXmlProp<double>(prop, tmp)) {
+    value = tmp;
+    return true;
+  } else {
+    return false;
+  }
+}
+
+template <>
+bool Widget::GetPersistentXmlProp(std::string prop, int32_t &value) {
+  double tmp;
+  if (GetPersistentXmlProp<double>(prop, tmp)) {
+    value = tmp;
+    return true;
+  } else {
+    return false;
+  }
+}
+
+template <>
+bool Widget::GetPersistentXmlProp(std::string prop, uint16_t &value) {
+  double tmp;
+  if (GetPersistentXmlProp<double>(prop, tmp)) {
+    value = tmp;
+    return true;
+  } else {
+    return false;
+  }
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, string value, xmlNodePtr node) {
+  if (node == NULL)
+    node = pimpl_->send_node;
+  xmlSetProp(node, (xmlChar *)prop.c_str(), (xmlChar *)value.c_str());
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, char *value, xmlNodePtr node) {
+  if (node == NULL)
+    node = pimpl_->send_node;
+  xmlSetProp(node, (xmlChar *)prop.c_str(), (xmlChar *)value);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, double value, xmlNodePtr node) {
+  xmlChar *xmlChar_value = xmlXPathCastNumberToString(value);
+
+  if (node == NULL)
+    node = pimpl_->send_node;
+  xmlSetProp(node, (xmlChar *)prop.c_str(), xmlChar_value);
+  xmlFree(xmlChar_value);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, float value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, int32_t value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, uint32_t value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, int16_t value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, uint16_t value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, int8_t value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, uint8_t value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, bool value, xmlNodePtr node) {
+  SetVolatileXmlProp<double>(prop, value, node);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, xmlChar *value, xmlNodePtr node) {
+  if (node == NULL)
+    node = pimpl_->send_node;
+  xmlSetProp(node, (xmlChar *)prop.c_str(), value);
+}
+
+template <>
+void Widget::SetVolatileXmlProp(string prop, DataType const &dataType,
+                                xmlNodePtr node) {
+  if (node == NULL)
+    node = pimpl_->send_node;
+  xmlSetProp(node, (xmlChar *)prop.c_str(),
+             (xmlChar *)dataType.GetDescription().c_str());
+  /*
+      switch(dataType)
+      {
+          case io_data::Float:
+              xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)"float");
+              break;
+          case io_data::Int8_t:
+              xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)"int8_t");
+              break;
+          case io_data::Int16_t:
+              xmlSetProp(node,(xmlChar*)prop.c_str(),(xmlChar*)"int16_t");
+              break;
+      }
+      */
+}
+
+template <> void Widget::SetPersistentXmlProp(std::string prop, double value) {
+  SetVolatileXmlProp(prop, value);
+  SetVolatileXmlProp(prop, value, pimpl_->file_node);
+}
+
+template <> void Widget::SetPersistentXmlProp(std::string prop, float value) {
+  SetVolatileXmlProp(prop, value);
+  SetVolatileXmlProp(prop, value, pimpl_->file_node);
+}
+
+template <> void Widget::SetPersistentXmlProp(std::string prop, int32_t value) {
+  SetVolatileXmlProp(prop, value);
+  SetVolatileXmlProp(prop, value, pimpl_->file_node);
+}
+
+template <>
+void Widget::SetPersistentXmlProp(std::string prop, uint16_t value) {
+  SetVolatileXmlProp(prop, value);
+  SetVolatileXmlProp(prop, value, pimpl_->file_node);
+}
+
+template <> void Widget::SetPersistentXmlProp(std::string prop, bool value) {
+  SetVolatileXmlProp(prop, value);
+  SetVolatileXmlProp(prop, value, pimpl_->file_node);
+}
+
+void Widget::SendXml(void) { pimpl_->SendXml(); }
+
+void Widget::setEnabled(bool status) { pimpl_->setEnabled(status); }
+
+bool Widget::isEnabled(void) const { return pimpl_->isenabled; }
 
 } // end namespace gui
Index: trunk/lib/FlairCore/src/Widget.h
===================================================================
--- trunk/lib/FlairCore/src/Widget.h	(revision 14)
+++ trunk/lib/FlairCore/src/Widget.h	(revision 15)
@@ -21,125 +21,129 @@
 class FrameworkManager_impl;
 
-namespace flair
-{
-namespace gui
-{
+namespace flair {
+namespace gui {
 
-    /*! \class Widget
-    *
-    * \brief Abstract class for all Framework's widget classes
-    *
-    * A widget is an object to display on the ground station. \n
-    * Communication with ground station is done through xml files; properties of theses files
-    * are modified through appropriate method. \n
-    * A xml file is used for default values of the Widget, if it has been specified in the
-    *  constructor of the FrameworkManager.
-    */
-    class Widget: public core::Object
-    {
-        friend class core::FrameworkManager;
-        friend class ::Widget_impl;
-        friend class ::FrameworkManager_impl;
+/*! \class Widget
+*
+* \brief Abstract class for all Framework's widget classes
+*
+* A widget is an object to display on the ground station. \n
+* Communication with ground station is done through xml files; properties of
+*theses files
+* are modified through appropriate method. \n
+* A xml file is used for default values of the Widget, if it has been specified
+*in the
+*  constructor of the FrameworkManager.
+*/
+class Widget : public core::Object {
+  friend class core::FrameworkManager;
+  friend class ::Widget_impl;
+  friend class ::FrameworkManager_impl;
 
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Widget, the xml file specified to the FrameworkManager's
-            * constructor is sued for default values. \n
-            * Two Widget with same parent must have different names. If a brother Widget already
-            * has the same name, the name of the new one will be automatically changed. \n
-            * Type must agree with predifined (hard coded) types
-            * in ground station code.
-            *
-            * \param parent parent
-            * \param name name
-            * \param type type
-            */
-            Widget(const Widget* parent,std::string name,std::string type);
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Widget, the xml file specified to the FrameworkManager's
+  * constructor is sued for default values. \n
+  * Two Widget with same parent must have different names. If a brother Widget
+  *already
+  * has the same name, the name of the new one will be automatically changed. \n
+  * Type must agree with predifined (hard coded) types
+  * in ground station code.
+  *
+  * \param parent parent
+  * \param name name
+  * \param type type
+  */
+  Widget(const Widget *parent, std::string name, std::string type);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            virtual ~Widget();
+  /*!
+  * \brief Destructor
+  *
+  */
+  virtual ~Widget();
 
-            /*!
-            * \brief Set enabled
-            *
-            * Enable or disable the Widget on the ground station. \n
-            * A disabled widget is greyed out on the ground station
-            * and in unmodifiable.
-            *
-            * \param status
-            */
-            void setEnabled(bool status);
+  /*!
+  * \brief Set enabled
+  *
+  * Enable or disable the Widget on the ground station. \n
+  * A disabled widget is greyed out on the ground station
+  * and in unmodifiable.
+  *
+  * \param status
+  */
+  void setEnabled(bool status);
 
-            /*!
-            * \brief Is enabled?
-            *
-            * \return true if widget is enabled
-            */
-            bool isEnabled(void) const;
+  /*!
+  * \brief Is enabled?
+  *
+  * \return true if widget is enabled
+  */
+  bool isEnabled(void) const;
 
-        protected:
-            /*!
-            * \brief Set a persistent xml property
-            *
-            * The property will be saved in the configuration xml and also used to configure the ground station.
-            *
-            * \param prop property to set and save
-            * \param value value to set and save
-            */
-            template <typename T>
-            void SetPersistentXmlProp(std::string prop,T value);
+protected:
+  /*!
+  * \brief Set a persistent xml property
+  *
+  * The property will be saved in the configuration xml and also used to
+  *configure the ground station.
+  *
+  * \param prop property to set and save
+  * \param value value to set and save
+  */
+  template <typename T> void SetPersistentXmlProp(std::string prop, T value);
 
-            /*!
-            * \brief Get a persistent xml property
-            *
-            * Get the property from the xml file. If no corresponding property is found in the xml, value remains unchanged. \n
-            * Thus value can be initialized with a default value before calling this method.
-            *
-            * \param prop property to get
-            * \param value value to store the result
-            * \return true if value was changed
-            */
-            template <typename T>
-            bool GetPersistentXmlProp(std::string prop,T &value);
+  /*!
+  * \brief Get a persistent xml property
+  *
+  * Get the property from the xml file. If no corresponding property is found in
+  *the xml, value remains unchanged. \n
+  * Thus value can be initialized with a default value before calling this
+  *method.
+  *
+  * \param prop property to get
+  * \param value value to store the result
+  * \return true if value was changed
+  */
+  template <typename T> bool GetPersistentXmlProp(std::string prop, T &value);
 
-            /*!
-            * \brief Set a volatile xml property
-            *
-            * This property should be used to configure the ground station (one time init). \n
-            * The property will be destroyed after calling SendXml() as it should no be used anymore.
-            *
-            * \param prop property to set
-            * \param value value to set
-            * \param node if sepcified, node to set; otherwise use the node of the Widget
-            */
-            template <typename T>
-            void SetVolatileXmlProp(std::string prop,T value,xmlNodePtr node=NULL);
+  /*!
+  * \brief Set a volatile xml property
+  *
+  * This property should be used to configure the ground station (one time
+  *init). \n
+  * The property will be destroyed after calling SendXml() as it should no be
+  *used anymore.
+  *
+  * \param prop property to set
+  * \param value value to set
+  * \param node if sepcified, node to set; otherwise use the node of the Widget
+  */
+  template <typename T>
+  void SetVolatileXmlProp(std::string prop, T value, xmlNodePtr node = NULL);
 
-            /*!
-            * \brief Send xml
-            *
-            * Send Widget's xml to ground station. \n
-            * New changes will be taken into account by ground station. \n
-            * All volatile properties will be erased after calling ths method, as they should not be used anymore.
-            */
-            void SendXml(void);
+  /*!
+  * \brief Send xml
+  *
+  * Send Widget's xml to ground station. \n
+  * New changes will be taken into account by ground station. \n
+  * All volatile properties will be erased after calling ths method, as they
+  *should not be used anymore.
+  */
+  void SendXml(void);
 
-            /*!
-            * \brief Xml event
-            *
-            * This method must be reimplemented to handle a xml event. \n
-            * It is automatically called when something changed from
-            * ground station. \n
-            */
-            virtual void XmlEvent(void){};
+  /*!
+  * \brief Xml event
+  *
+  * This method must be reimplemented to handle a xml event. \n
+  * It is automatically called when something changed from
+  * ground station. \n
+  */
+  virtual void XmlEvent(void){};
 
-         private:
-            class Widget_impl* pimpl_;
-    };
+private:
+  class Widget_impl *pimpl_;
+};
 
 } // end namespace gui
